---------------------------------------------------
-- CONFIGURATION -> config.lua
-- NOT HERE!
---------------------------------------------------
local config = whoaUnitFrames.config
local _, class = UnitClass("player")
local classcolor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
local color = nil
local fhp, php, thp , pmp = 0
local fm, pm, tm = 0
local fhpMax, phpMax, thpMax , pmpMax = 0
local fhpPercent, phpPercent, thpPercent , pmpPercent = 0
local tmpPercent, fmpPercent, tmpMax, fmpMax = 0;

---------------------------------------------------
-- DK RUNES
---------------------------------------------------
if class == "DEATHKNIGHT" then
    RuneButtonIndividual1:ClearAllPoints()
    RuneButtonIndividual1:SetPoint("TOPLEFT", PlayerFrameManaBar, "BOTTOMLEFT", -1, -5)
end

---------------------------------------------------
-- PARTY
---------------------------------------------------
local function whoa_partyColors()
    if not InCombatLockdown() then
        local partyMembers = GetNumPartyMembers()
        if partyMembers > 0 then
            for i = 1, partyMembers do
                color = RAID_CLASS_COLORS[select(2, UnitClass("party"..i))]
                if color then
                    _G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarColor(color.r, color.g, color.b)
                    _G["PartyMemberFrame"..i.."HealthBar"].lockColor = true
                end
            end    
        end
    end
end

---------------------------------------------------
-- PLAYERFRAME
---------------------------------------------------
local function whoa_playerFrame()
    if not UnitHasVehicleUI("player") then
        PlayerName:SetWidth(0.01)
        PlayerFrameGroupIndicatorText:ClearAllPoints()
        PlayerFrameGroupIndicatorText:SetPoint("BOTTOMLEFT", PlayerFrame, "TOP", 0, -20)
        PlayerFrameGroupIndicatorLeft:Hide()
        PlayerFrameGroupIndicatorMiddle:Hide()
        PlayerFrameGroupIndicatorRight:Hide()
        PlayerFrameHealthBar:ClearAllPoints()
        PlayerFrameHealthBar:SetPoint("TOPLEFT", 106, -24)
        PlayerFrameHealthBar:SetHeight(18)
        if classcolor and config.classColorPlayer then
            PlayerFrameHealthBar:SetStatusBarColor(classcolor.r, classcolor.g, classcolor.b)
            PlayerFrameHealthBar.lockColor = true
        else
            color = FACTION_BAR_COLORS[8] -- 8 is exalted
            if color then
                PlayerFrameHealthBar:SetStatusBarColor(color.r, color.g, color.b)
                PlayerFrameHealthBar.lockColor = true
            end
        end
        PlayerFrameHealthBarText:ClearAllPoints()
        PlayerFrameHealthBarText:SetPoint("CENTER", PlayerFrameHealthBar, "CENTER", 0, 0)
        PlayerFrameManaBar:ClearAllPoints()
        PlayerFrameManaBar:SetPoint("TOPLEFT", 106, -45)
        PlayerFrameManaBar:SetHeight(17)
        PlayerFrameManaBarText:ClearAllPoints()
        PlayerFrameManaBarText:SetPoint("CENTER", PlayerFrameManaBar, "CENTER", 0, 0)
    else
        if config.classColorPlayer then
            color = FACTION_BAR_COLORS[8] -- 8 is exalted
            if color then
                PlayerFrameHealthBar:SetStatusBarColor(color.r, color.g, color.b)
                PlayerFrameHealthBar.lockColor = true
            end
        end
        PlayerFrameHealthBar:SetHeight(12)
        PlayerFrameManaBar:SetHeight(12)
    end
end
hooksecurefunc("PlayerFrame_UpdateArt", whoa_playerFrame)
hooksecurefunc("PlayerFrame_SequenceFinished", whoa_playerFrame)

---------------------------------------------------
-- TARGETFRAME
---------------------------------------------------
local function whoa_targetFrame()
    TargetFrame.nameBackground:Hide()
    TargetFrame.deadText:ClearAllPoints()
    TargetFrame.deadText:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, 0)
    TargetFrameTextureFrameName:ClearAllPoints()
    TargetFrameTextureFrameName:SetPoint("BOTTOMRIGHT", TargetFrame, "TOP", 0, -20)
    TargetFrameHealthBar:ClearAllPoints()
    TargetFrameHealthBar:SetPoint("TOPLEFT", 5, -24)
    TargetFrameHealthBar:SetHeight(18)
    TargetFrameTextureFrameHealthBarText:ClearAllPoints()
    TargetFrameTextureFrameHealthBarText:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, 0)
    TargetFrameManaBar:ClearAllPoints()
    TargetFrameManaBar:SetPoint("TOPLEFT", 5, -45)
    TargetFrameManaBar:SetHeight(17)
    TargetFrameTextureFrameManaBarText:ClearAllPoints()
    TargetFrameTextureFrameManaBarText:SetPoint("CENTER", TargetFrameManaBar, "CENTER", 0, 0)
    TargetFrame.threatNumericIndicator:SetPoint("BOTTOM", PlayerFrame, "TOP", 75, -22)
end

local function whoa_targetChange()
    if UnitIsPlayer("target") and config.classColorTarget then
        color = RAID_CLASS_COLORS[select(2, UnitClass("target"))]
    else
        color = FACTION_BAR_COLORS[UnitReaction("target", "player")]
    end
    if ( not UnitPlayerControlled("target") and UnitIsTapped("target") and not UnitIsTappedByPlayer("target") and not UnitIsTappedByAllThreatList("target") ) then
        TargetFrameHealthBar:SetStatusBarColor(0.5, 0.5, 0.5)
    else
        if color then
            TargetFrameHealthBar:SetStatusBarColor(color.r, color.g, color.b)
            TargetFrameHealthBar.lockColor = true
        end
    end
end
hooksecurefunc("TargetFrame_CheckFaction", whoa_targetChange)

-- Code from Blizzards TargetFrame.lua
function whoa_targetUpdateAuraPositions(self, auraName, numAuras, numOppositeAuras, largeAuraList, updateFunc, maxRowWidth, offsetX)
    -- aura positioning constants
    local AURA_OFFSET_Y = 3;
    local LARGE_AURA_SIZE = config.largeAuraSize;
    local SMALL_AURA_SIZE = config.smallAuraSize;
--  local AURA_ROW_WIDTH = 122;
--  local NUM_TOT_AURA_ROWS = 3;
    local size;
    local offsetY = AURA_OFFSET_Y;
    local rowWidth = 0;
    local firstBuffOnRow = 1;
    for i=1, numAuras do
        if ( largeAuraList[i] ) then
            size = LARGE_AURA_SIZE;
            offsetY = AURA_OFFSET_Y + AURA_OFFSET_Y;
        else
            size = SMALL_AURA_SIZE;
        end
        if ( i == 1 ) then
            rowWidth = size;
            self.auraRows = self.auraRows + 1;
        else
            rowWidth = rowWidth + size + offsetX;
        end
        if ( rowWidth > maxRowWidth ) then
            updateFunc(self, auraName, i, numOppositeAuras, firstBuffOnRow, size, offsetX, offsetY);
            rowWidth = size;
            self.auraRows = self.auraRows + 1;
            firstBuffOnRow = i;
            offsetY = AURA_OFFSET_Y;
--          if ( self.auraRows > NUM_TOT_AURA_ROWS ) then
--              maxRowWidth = AURA_ROW_WIDTH;
--          end
        else
            updateFunc(self, auraName, i, numOppositeAuras, i - 1, size, offsetX, offsetY);
        end
    end
end
hooksecurefunc("TargetFrame_UpdateAuraPositions", whoa_targetUpdateAuraPositions)

---------------------------------------------------
-- FOCUSFRAME
---------------------------------------------------
local function whoa_focusFrame()
    FocusFrame.nameBackground:Hide()
    FocusFrame.deadText:ClearAllPoints()
    FocusFrame.deadText:SetPoint("CENTER", FocusFrameHealthBar, "CENTER", 0, 0)
    FocusFrameTextureFrameName:ClearAllPoints()
    FocusFrameHealthBar:ClearAllPoints()
    FocusFrameHealthBar:SetPoint("TOPLEFT", 5, -24)
    FocusFrameHealthBar:SetHeight(18)
    FocusFrameManaBar:ClearAllPoints()
    FocusFrameManaBar:SetPoint("TOPLEFT", 5, -45)
    FocusFrameManaBar:SetHeight(17)
    FocusFrame.threatNumericIndicator:SetWidth(0.01)
    FocusFrame.threatNumericIndicator.bg:Hide()
    FocusFrame.threatNumericIndicator.text:Hide()
end

local function whoa_focusChange()
    if UnitIsPlayer("focus") and config.classColorFocus then
        color = RAID_CLASS_COLORS[select(2, UnitClass("focus"))]
    else
        color = FACTION_BAR_COLORS[UnitReaction("focus", "player")]
    end
    if color then
        FocusFrameHealthBar:SetStatusBarColor(color.r, color.g, color.b)
        FocusFrameHealthBar.lockColor = true
    end
end

---------------------------------------------------
-- TEXTE
---------------------------------------------------
local fplayerpercent = CreateFrame("Frame", "whoaPlayerPercent", PlayerFrameHealthBar)
fplayerpercent:SetPoint("LEFT", PlayerFrameHealthBar, "LEFT", 0, 0)
fplayerpercent:SetWidth(40)
fplayerpercent:SetHeight(20)
fplayerpercent.text = fplayerpercent:CreateFontString("PlayerPercentText", "OVERLAY")
fplayerpercent.text:SetAllPoints(fplayerpercent)
fplayerpercent.text:SetFontObject(TextStatusBarText)
fplayerpercent.text:SetJustifyH("RIGHT")

local fplayerhealth = CreateFrame("Frame", "whoaPlayerHealth", PlayerFrameHealthBar)
fplayerhealth:SetPoint("RIGHT", PlayerFrameHealthBar, "RIGHT", -5, 0)
fplayerhealth:SetWidth(75)
fplayerhealth:SetHeight(20)
fplayerhealth.text = fplayerhealth:CreateFontString("PlayerHealthText", "OVERLAY")
fplayerhealth.text:SetAllPoints(fplayerhealth)
fplayerhealth.text:SetFontObject(TextStatusBarText)
fplayerhealth.text:SetJustifyH("RIGHT")

local fplayermana = CreateFrame("Frame", "whoaPlayerMana", PlayerFrameManaBar)
fplayermana:SetPoint("RIGHT", PlayerFrameManaBar, "RIGHT", -5, 0)
fplayermana:SetWidth(75)
fplayermana:SetHeight(20)
fplayermana.text = fplayermana:CreateFontString("PlayerManaText", "OVERLAY")
fplayermana.text:SetAllPoints(fplayermana)
fplayermana.text:SetFontObject(TextStatusBarText)
fplayermana.text:SetJustifyH("RIGHT")

local fplayermanapercent = CreateFrame("Frame", "whoaPlayerManaPercent", PlayerFrameManaBar)
fplayermanapercent:SetPoint("LEFT", PlayerFrameManaBar, "LEFT", 0, 0)
fplayermanapercent:SetWidth(40)
fplayermanapercent:SetHeight(20)
fplayermanapercent.text = fplayermanapercent:CreateFontString("PlayerPercentText", "OVERLAY")
fplayermanapercent.text:SetAllPoints(fplayermanapercent)
fplayermanapercent.text:SetFontObject(TextStatusBarText)
fplayermanapercent.text:SetJustifyH("RIGHT")

local ftargetpercent = CreateFrame("Frame", "whoaTargetPercent", TargetFrameHealthBar)
ftargetpercent:SetPoint("LEFT", TargetFrameHealthBar, "LEFT", 0, 0)
ftargetpercent:SetWidth(40)
ftargetpercent:SetHeight(20)
ftargetpercent.text = ftargetpercent:CreateFontString("TargetPercentText", "OVERLAY")
ftargetpercent.text:SetAllPoints(ftargetpercent)
ftargetpercent.text:SetFontObject(TextStatusBarText)
ftargetpercent.text:SetJustifyH("RIGHT")

local ftargetmanapercent = CreateFrame("Frame", "whoaTargetManaPercent", TargetFrameManaBar)
ftargetmanapercent:SetPoint("LEFT", TargetFrameManaBar, "LEFT", 0, 0)
ftargetmanapercent:SetWidth(40)
ftargetmanapercent:SetHeight(20)
ftargetmanapercent.text = ftargetmanapercent:CreateFontString("TargetPercentText", "OVERLAY")
ftargetmanapercent.text:SetAllPoints(ftargetmanapercent)
ftargetmanapercent.text:SetFontObject(TextStatusBarText)
ftargetmanapercent.text:SetJustifyH("RIGHT")

local ftargethealth = CreateFrame("Frame", "whoaTargetHealth", TargetFrameHealthBar)
ftargethealth:SetPoint("RIGHT", TargetFrameHealthBar, "RIGHT", -5, 0)
ftargethealth:SetWidth(75)
ftargethealth:SetHeight(20)
ftargethealth.text = ftargethealth:CreateFontString("TargetHealthText", "OVERLAY")
ftargethealth.text:SetAllPoints(ftargethealth)
ftargethealth.text:SetFontObject(TextStatusBarText)
ftargethealth.text:SetJustifyH("RIGHT")

local ftargetmana = CreateFrame("Frame", "whoaTargetMana", TargetFrameManaBar)
ftargetmana:SetPoint("RIGHT", TargetFrameManaBar, "RIGHT", -5, 0)
ftargetmana:SetWidth(75)
ftargetmana:SetHeight(20)
ftargetmana.text = ftargetmana:CreateFontString("TargetManaText", "OVERLAY")
ftargetmana.text:SetAllPoints(ftargetmana)
ftargetmana.text:SetFontObject(TextStatusBarText)
ftargetmana.text:SetJustifyH("RIGHT")

local ffocuspercent = CreateFrame("Frame", "whoaFocusPercent", FocusFrameHealthBar)
ffocuspercent:SetPoint("LEFT", FocusFrameHealthBar, "LEFT", -45, 0)
ffocuspercent:SetWidth(40)
ffocuspercent:SetHeight(20)
ffocuspercent.text = ffocuspercent:CreateFontString("FocusPercentText", "OVERLAY")
ffocuspercent.text:SetAllPoints(ffocuspercent)
ffocuspercent.text:SetFontObject(TextStatusBarText)
ffocuspercent.text:SetJustifyH("RIGHT")

local ffocusmanapercent = CreateFrame("Frame", "whoaFocusManaPercent", FocusFrameManaBar)
ffocusmanapercent:SetPoint("LEFT", FocusFrameManaBar, "LEFT", -45, 0)
ffocusmanapercent:SetWidth(40)
ffocusmanapercent:SetHeight(20)
ffocusmanapercent.text = ffocusmanapercent:CreateFontString("FocusPercentText", "OVERLAY")
ffocusmanapercent.text:SetAllPoints(ffocusmanapercent)
ffocusmanapercent.text:SetFontObject(TextStatusBarText)
ffocusmanapercent.text:SetJustifyH("RIGHT")

local function whoa_round(n, dp)
    return math.floor((n * 10^dp) + .5) / (10^dp)
end

local function whoa_format(n)
    local strLen = strlen(n)
--  if config.simpleHealth and n > 999999999 then
    if config.simpleHealth and strLen > 9 then
        return whoa_round(n/1e9, 1)..config.phrases["giga"]
--  elseif config.simpleHealth and n > 999999 then
    elseif config.simpleHealth and strLen > 6 then
        return whoa_round(n/1e6, 1)..config.phrases["mega"]
--  elseif config.simpleHealth and strLen > 5 then -- no simpleHealth under 100.000
    elseif config.simpleHealth and n > 199999 then -- no simpleHealth under 199.999
        return whoa_round(n/1e3, 0)..config.phrases["kilo"]
    elseif config.thousandSeparators then
        local left, num, right = string.match(n, '^([^%d]*%d)(%d*)(.-)')
        return left..(num:reverse():gsub('(%d%d%d)', '%1'..config.phrases["1000 separator"]):reverse())..right
    else
        return n
    end
end

local function whoa_ufText()
    -- focus
    fhp = FocusFrameHealthBar:GetValue()
    if fhp > 0 then
        if UnitIsDeadOrGhost("focus") then
            ffocuspercent:Hide()
			ffocusmanapercent:Hide()
            if UnitIsGhost("focus") then
                FocusFrameTextureFrameHealthBarText:SetText(config.phrases["Ghost"])
            else
                FocusFrameTextureFrameHealthBarText:SetText(config.phrases["Dead"])
            end
        else
            FocusFrameTextureFrameHealthBarText:SetText(whoa_format(fhp))
            if GetCVarBool("statusTextPercentage") then
                -- hp %
				_, fhpMax = FocusFrameHealthBar:GetMinMaxValues()
                fhpPercent = math.floor((fhp / fhpMax) * 100)
                ffocuspercent:Show()
                ffocuspercent.text:SetText(fhpPercent.."%")
				
            end
        end
    end
    FocusFrameTextureFrameHealthBarText:ClearAllPoints()
    FocusFrameTextureFrameHealthBarText:SetPoint("CENTER", FocusFrameHealthBar, "CENTER", 0, 0)
    fm = FocusFrameManaBar:GetValue()
    if fm > 0 then
        if UnitIsDeadOrGhost("focus") then
            FocusFrameTextureFrameManaBarText:SetText()
        else
            FocusFrameTextureFrameManaBarText:SetText(whoa_format(fm))
			if GetCVarBool("statusTextPercentage") then
				-- mana %
				_, fmpMax = FocusFrameManaBar:GetMinMaxValues()
				fmpPercent = math.floor((fm / fmpMax) * 100)
				ffocusmanapercent:Show()
				ffocusmanapercent.text:SetText(fmpPercent.."%")
			end
        end
    else
        FocusFrameTextureFrameManaBarText:SetText()
    end
    if not UnitIsConnected("focus") then
        FocusFrameTextureFrameManaBarText:SetText(config.phrases["Offline"])
    end
    FocusFrameTextureFrameManaBarText:ClearAllPoints()
    FocusFrameTextureFrameManaBarText:SetPoint("CENTER", FocusFrameManaBar, "CENTER", 0, 0)
    -- player
    php = PlayerFrameHealthBar:GetValue()
    if php > 0 then
        if UnitIsDeadOrGhost("player") then
            fplayerhealth:Hide()
            fplayerpercent:Hide()
            if UnitIsGhost("player") then
                PlayerFrameHealthBarText:SetText(config.phrases["Ghost"])
            else
                PlayerFrameHealthBarText:SetText(config.phrases["Dead"])
            end
        else
            PlayerFrameHealthBarText:SetText()
            fplayerhealth:Show()
            fplayerhealth.text:SetText(whoa_format(php))
            if GetCVarBool("statusTextPercentage") then
                _, phpMax = PlayerFrameHealthBar:GetMinMaxValues()
                phpPercent = math.floor((php / phpMax) * 100)
                fplayerpercent:Show()
                fplayerpercent.text:SetText(phpPercent.."%")
            end
        end
    else
        if UnitIsDeadOrGhost("player") then
            if UnitIsGhost("player") then
                PlayerFrameHealthBarText:SetText(config.phrases["Ghost"])
            else
                PlayerFrameHealthBarText:SetText(config.phrases["Dead"])
            end
        end
        fplayerpercent:Hide()
        fplayerhealth:Hide()
    end
    pm = PlayerFrameManaBar:GetValue()
    PlayerFrameManaBarText:SetText()
    if pm > 0 then
        if UnitIsDeadOrGhost("player") then
            fplayermana:Hide()
			fplayermanapercent:Hide();
        else
            fplayermana:Show()
            fplayermana.text:SetText(whoa_format(pm))
			if GetCVarBool("statusTextPercentage") then
				_, pmpMax = PlayerFrameManaBar:GetMinMaxValues()
				pmpPercent = math.floor((pm / pmpMax) * 100)
				fplayermanapercent:Show()
				fplayermanapercent.text:SetText(pmpPercent.."%")
			end
        end
    else
        fplayermana:Hide()
		fplayermanapercent:Hide()
    end
    -- target
    thp = TargetFrameHealthBar:GetValue()
    if thp > 0 then
        if UnitIsDeadOrGhost("target") then
            ftargethealth:Hide()
            ftargetpercent:Hide()
            if UnitIsGhost("target") then
                TargetFrameTextureFrameHealthBarText:SetText(config.phrases["Ghost"])
            else
                TargetFrameTextureFrameHealthBarText:SetText(config.phrases["Dead"])
            end
        else
            TargetFrameTextureFrameHealthBarText:SetText()
            ftargethealth:Show()
            ftargethealth.text:SetText(whoa_format(thp))
            if GetCVarBool("statusTextPercentage") then
                _, thpMax = TargetFrameHealthBar:GetMinMaxValues()
                thpPercent = math.floor((thp / thpMax) * 100)
                ftargetpercent:Show()
                ftargetpercent.text:SetText(thpPercent.."%")
            end
        end
    else
        ftargetpercent:Hide()
        ftargethealth:Hide()
    end
    tm = TargetFrameManaBar:GetValue()
    TargetFrameTextureFrameManaBarText:SetText()
    if tm > 0 then
        if UnitIsDeadOrGhost("target") then
            ftargetmana:Hide()
			ftargetmanapercent:Hide()
        else
            ftargetmana:Show()
            ftargetmana.text:SetText(whoa_format(tm))
			if GetCVarBool("statusTextPercentage") then
				_, tmpMax = TargetFrameManaBar:GetMinMaxValues()
				tmpPercent = math.floor((tm / tmpMax) * 100)
				ftargetmanapercent:Show()
				ftargetmanapercent.text:SetText(tmpPercent.."%")
			end
        end
    else
        ftargetmana:Hide()
    end
    if not UnitIsConnected("target") then
        ftargetmana:Hide()
        TargetFrameTextureFrameManaBarText:SetText(config.phrases["Offline"])
    end
end
hooksecurefunc("TextStatusBar_Initialize", whoa_ufText)
hooksecurefunc("TextStatusBar_OnEvent", whoa_ufText)
hooksecurefunc("TextStatusBar_UpdateTextString", whoa_ufText)
hooksecurefunc("TextStatusBar_OnValueChanged", whoa_ufText)
hooksecurefunc("HideTextStatusBarText", whoa_ufText)

---------------------------------------------------
-- CVAR_UPDATES
---------------------------------------------------
local function whoa_cvarUpdate()
    if GetCVarBool("fullSizeFocusFrame") then
        FocusFrameTextureFrameName:SetPoint("BOTTOMRIGHT", FocusFrame, "TOP", 0, -20)
    else
        FocusFrameTextureFrameName:SetPoint("BOTTOMRIGHT", FocusFrame, "TOP", 10, -20)
    end
    if GetCVarBool("statusTextPercentage") then
        if GetCVarBool("playerStatusText") then
            fplayerpercent:Show()
            fplayerhealth:Show()
            fplayermana:Show()
			fplayermanapercent:Show()
        else
            fplayerpercent:Hide()
            fplayerhealth:Hide()
            fplayermana:Hide()
			fplayermanapercent:Hide()
        end
        if GetCVarBool("targetStatusText") then
            ftargetpercent:Show()
            ftargethealth:Show()
            ftargetmana:Show()
			ftargetmanapercent:Show()
            ffocuspercent:Show()
			ffocusmanapercent:Show()
        else
            ftargetpercent:Hide()
            ftargethealth:Hide()
            ftargetmana:Hide()
			ftargetmanapercent:Hide()
            ffocuspercent:Hide()
			ffocusmanapercent:Hide()
        end
    else
        fplayerpercent:Hide()
		fplayermanapercent:Hide()
        ftargetpercent:Hide()
		ftargetmanapercent:Hide()
        ffocuspercent:Hide()
		ffocusmanapercent:Hide()
        if GetCVarBool("playerStatusText") then
            fplayerhealth:Show()
            fplayermana:Show()
        else
            fplayerhealth:Hide()
            fplayermana:Hide()
        end
        if GetCVarBool("targetStatusText") then
            ftargethealth:Show()
            ftargetmana:Show()
        else
            ftargethealth:Hide()
            ftargetmana:Hide()
        end
    end
end

---------------------------------------------------
-- EVENTS
---------------------------------------------------
local w = CreateFrame("Frame", nil, UIParent)
w:RegisterEvent("PLAYER_ENTERING_WORLD")
w:RegisterEvent("PLAYER_REGEN_ENABLED")
w:RegisterEvent("PLAYER_TARGET_CHANGED")
w:RegisterEvent("PLAYER_FOCUS_CHANGED")
w:RegisterEvent("CVAR_UPDATE")
if config.classColorParty then
    w:RegisterEvent("PARTY_MEMBERS_CHANGED")
end
function w:OnEvent(event, ...)
    if event == "PLAYER_ENTERING_WORLD" then
        SlashCmdList['RELOAD'] = function() ReloadUI() end
        SLASH_RELOAD1 = '/rl'
        whoa_playerFrame()
        whoa_targetFrame()
        whoa_focusFrame()
        whoa_ufText()
        whoa_cvarUpdate()
    elseif event == "PLAYER_REGEN_ENABLED" then
        whoa_playerFrame()
    elseif event == "PLAYER_TARGET_CHANGED" then
        whoa_targetChange()
    elseif event == "PLAYER_FOCUS_CHANGED" then
        whoa_focusChange()
    elseif event == "CVAR_UPDATE" then
        whoa_cvarUpdate()
    elseif event == "PARTY_MEMBERS_CHANGED" then
        whoa_partyColors()
    end
end
w:SetScript("OnEvent", w.OnEvent)
